#include <stdlib.h>
#include <stdio.h>
#include <string.h>

const int maxn = 10001;
const int en = 200001;
const int len = 2001;

int n,m,k;
int g[maxn],g1[maxn],u[en],v[en],next[en];
int num[maxn],vis[maxn],comp[maxn],deg[maxn],seq[maxn];
int ans[len];

void Add(int i)
{
   next[i] = g[u[i]]; g[u[i]] = i;
}

void Add1(int i)
{
   next[i] = g1[u[i]]; g1[u[i]] = i;
}

void Dfs(int x)
{
   int i = g[x]; vis[x] = 1;
   while (i) {
      if (!vis[v[i]]) Dfs(v[i]);
      i = next[i];
   }
   k++; seq[k] = x;
}

void Dfs1(int x)
{
   int i = g1[x]; vis[x] = 1;
   while (i) {
      if (!vis[v[i]]) Dfs1(v[i]);
      i = next[i];
   }
   comp[x] = k; num[k]++;
}

void IL(int *a, int x)
{
   memset(a,0,sizeof(int)*len);
   a[0] = 1; a[1] = x;
}

void Mul(int *a, int x)
{
   int ost = 0,i,j;
   for (i = 1; i <= a[0]; i++) {
      j = a[i]*x + ost;
      a[i] = j%10; ost = j/10;
   }   
   while (ost != 0) {
      a[0]++; a[a[0]] = ost%10; ost /= 10;
   }
}

void WL(int *a)
{
   int i;
   for (i = a[0]; i >= 1; i--) printf("%c",'0' + a[i]);
}

int main()
{
   int i;
   
   freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
   scanf("%d%d",&n,&m); memset(g,0,sizeof(g));
   memset(g1,0,sizeof(g1));
   for (i = 1; i <= m; i++) {
      scanf("%d%d",&u[i],&v[i]); Add(i);      
      u[m+i] = v[i]; v[m+i] = u[i]; Add1(m+i);
   }
   
   memset(vis,0,sizeof(vis)); k = 0;
   for (i = 1; i <= n; i++) if (!vis[i]) Dfs(i);
   memset(vis,0,sizeof(vis)); k = 0;
   memset(num,0,sizeof(num));   
   for (i = n; i >= 1; i--) if (!vis[seq[i]]) {k++; Dfs1(seq[i]);}
   
   memset(deg,0,sizeof(deg));
   for (i = 1; i <= m; i++) 
      if (comp[u[i]] != comp[v[i]]) deg[comp[v[i]]]++;
   
   IL(ans,1);
   for (i = 1; i <= k; i++) 
      if (deg[i] == 0) Mul(ans,num[i]);
   
   WL(ans);
   fclose(stdin); fclose(stdout);
   return 0;
}